package com.crashnote.core.config;

public class ConfigParser {

    // INTERFACE ==================================================================================

    public int parseInt(final String str) {
        try {
            return Integer.parseInt(cleanup(str));
        } catch (NumberFormatException e) {
            throw new IllegalArgumentException("value " + str + " is not a number", e);
        }
    }

    public String parseString(final String value) {
        return cleanup(value);
    }

    public boolean parseBool(final String str) {
        final String s = cleanup(str);
        return "true".equals(s) || "yes".equals(s) || "y".equals(s) || "on".equals(s);
    }

    // INTERNALS ==================================================================================

    protected static String cleanup(final String str) {
        if (str != null) return str.trim().toLowerCase();
        else return str;
    }
}
